-- Spyro The Dragon ported to SRB2 by Nero1024
-- Spyro SRB2Persona integration by Gambit
-- Persona HUD artwork by EveDoesStuff
-- ( https://twitter.com/EveDoesStuff )
-- Sparx assets by DirkTheHusky and TrickyTex
-- Sparx code by Tatsuru
--additional edits by Nero1024

-- special thanks to Helius Universe#0616 for lua help

if not srb2p return end

--tableinsert stuff
table.insert(chargeableBonk, MT_REAPER)
table.insert(chargeableBonk, MT_SHEDEW)
table.insert(nonchargeableEnemies, MT_REAPER)

table.insert(nonflammableEnemies, MT_REAPER)
table.insert(nonflammableEnemies, MT_SHEDEW)
table.insert(nonflammableEnemies, MT_P3CHEST)

charStats["spyro"] = {

		-- GENERAL

		name = "Spyro",			-- This is only for bots / enemies
		basehp = 62,			-- base HP for level 1
		basesp = 38,
		persona = "sparx",
		melee_natk = "spyro_atk",	-- normal melee attack

		atk = 40,	-- attack power of physical attacks
		acc = 75,	-- accuracy of physical attacks
		crit = 30,

		supercolor_start = SKINCOLOR_PURPLE,	-- if super form is applicable: will use this flash

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
		-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_WAIT"},	-- standing (rare anim)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_SKID"},		-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},		-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_NDRL"},	-- attacking
		anim_aoa_end =		{SPR_PLAY, A, B, C, 2, "SPR2_NFLT"},	-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, C, 35, "SPR2_TRNS"},		-- taking damage
		anim_getdown =		{SPR_PLAY, A, B, C, 2, "SPR2_PAIN"},		-- knocked down from weakness / crit
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_SHIT"},		-- is down
		anim_getup =		{SPR_PLAY, A, B, C, A, B, C, A, B, C, 2, "SPR2_NFLT"},		-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DRWN"},		-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, E, 1, "SPR2_ROLL"},		-- gets revived
		anim_evoker =		{SPR_PLAY, A, B, C, A, B, C, A, B, C, A, B, C, A, B, C, A, B, C, A, B, C, 4, "SPR2_NFLT"},	-- holding evoker to head
		anim_evoker_shoot =	{SPR_PLAY, A, B, C, D, E, 4, "SPR2_TRNS"},		-- shooting evoker

		anim_stand_super = 	{SPR_PLAY, A, B, C, 4, "SPR2_NFLT"},		-- standing
		anim_stand_hurt_super = 	{SPR_PLAY, C, 8, "SPR2_TRNS"},		-- standing
		anim_stand_bored_super = 	{SPR_PLAY, A, B, C, 4, "SPR2_NFLT"},		-- standing
		anim_run_super = 	{SPR_PLAY, A, B, C, D, E, F, G, H, I, J, 3, "SPR2_FLY_"},	-- run
		anim_evoker_super = 	{SPR_PLAY, A, B, C, D, E, 4, "SPR2_TRNS"},
		anim_evoker_shoot_super = 	{SPR_PLAY, A, B, C, D, E, 4, "SPR2_TRNS"},
		
		anim_special2 = 	{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},

		-- VOICES
		-- Follow this template.
		-- All sounds in there will be *automatically* freeslotted.
		-- For custom characters, call VFX_freeslotC("skinname") OUT OF A THINKFRAME (!)
		-- See Player_Defs.LUA

		vfx_summon = {"sfx_spsum1", "sfx_spsum2", "sfx_spsum3", "sfx_spsum4", "sfx_spsum5", "sfx_spsum6", "sfx_spsum7", "sfx_spsum8",},
		vfx_skill = {"sfx_spskl1", "sfx_spskl2", "sfx_sphls1"},
		vfx_item = {"sfx_spuse1", "sfx_spuse2", "sfx_spuse3", "sfx_spuse4"},
		vfx_hurt = {"sfx_sphrt1", "sfx_sphrt2", "sfx_sphrt3", "sfx_sphrt4", "sfx_sphrt5", "sfx_sphrt6"},
		vfx_hurtx = {"sfx_sphtx1", "sfx_sphtx2", "sfx_sphtx3", "sfx_sphtx4", "sfx_sphtx5"},
		vfx_die = {"sfx_spdie1", "sfx_sphtx4"},
		vfx_killconfirm = {"sfx_spskl1", "sfx_spskl2", "sfx_sphls1"},
		vfx_heal = {"sfx_sphel1", "sfx_sphel2"},
		vfx_healself = {"sfx_sphls1", "sfx_spdge3"},
		vfx_kill = {"sfx_spkll1", "sfx_spkll2", "sfx_spkll3", "sfx_spkll4"},
		vfx_1more = {"sfx_sp1mr1", "sfx_sp1mr2", "sfx_sp1mr3", "sfx_spkll3", "sfx_sphel1"},
		vfx_crit = {"sfx_spcrt1", "sfx_spcrt2"},
		vfx_aoaask = {"sfx_spaoi1", "sfx_spaoi2",},
		vfx_aoado = {"sfx_spaoa1", "sfx_spaoa2", "sfx_spaoa3", "sfx_spaoa4"},
		vfx_aoarelent = {"sfx_spmis3"},
		vfx_miss = {"sfx_spmis1", "sfx_spmis2", "sfx_spmis3", "sfx_spmis4", "sfx_spmis5", "sfx_spmis6"},
		vfx_dodge = {"sfx_spdge1", "sfx_spdge2", "sfx_spdge3", "sfx_spdge4", "sfx_spdge5"},
		vfx_win = {"sfx_spwin1", "sfx_spwin2", "sfx_spwin3", "sfx_spwin4", "sfx_spwin5", "sfx_spwin6", "sfx_spwin7", "sfx_spwin8"},
		vfx_levelup = {"sfx_splvl1", "sfx_splvl2", "sfx_splvl3", "sfx_splvl4", "sfx_splvl5", "sfx_spwin7"},


		icon = "ICO_SPYR",	-- icon for net select and other menus
		hudbust = "SPYRO_H",			-- patch to draw on the stat hud
		hudaoa = "H_SPYAOA",	-- patch for all out attack hud
		hudsbust = "SPYRO_H",
		hudsaoa = "H_SPYAOA",	-- same but for supers
		hudcutin = "SPYRO_A",	-- cut in
		aoa_quote = "I think I smell \na barbecue!",

		tip = "Learns Maragi, Strike, and some \nsupportive tricks. A strong attacker, \nhis dragonscales make him resistant to \nElemental Magic damage. Otherwise, his \nsmall body won't help him against \nany Physical attacks he fails to dodge!",
}

personaList["sparx"] = {
		-- GENERAL
		name = "Sparx",
		arcana = ARCANA_MAGICIAN,

		-- STATS (at level 10. so we can have some precision, y'see)

		sprite = SPR_NULL,
		
		anim_idle = 	{SPR_NULL, 1},
		anim_atk = 		{SPR_NULL, 1},

		strength = 9,
		magic = 9,
		endurance = 5,
		luck = 6,
		agility = 10,
		weak = ATK_STRIKE|ATK_SLASH|ATK_PIERCE,
		resist = ATK_FIRE|ATK_ICE|ATK_ELEC|ATK_WIND,
		skills = {
					{"maragi", 1}, {"lunge", 1},
					{"nimble dragon", 12}, {"invigorate 1", 14},
					{"patra", 16},

					{"sonic punch", 18}, {"maragion", 22}, 
					{"assault dive", 24, "lunge"}, {"invigorate 2", 26, "invigorate 1"}, 
					{"fire boost", 28}, {"tetrakarn", 32, "sonic punch"}, 
					{"dextrous dragon", 36, "nimble dragon"}, 
					{"me patra", 38, "patra"}, {"gigantic fist", 42, "assault dive"}, 
					{"draconic boon", 46, "maragi"}, {"invigorate 3", 51, "invigorate 2"}, 
					{"maragidyne", 52, "maragion"}, {"agile dragon", 56, "dextrous dragon"}, 
					{"megaton raid", 60, "gigantic fist"}, 
					{"fire amp", 70, "fire boost"},
				},
}

attackDefs["nimble dragon"] = {
		name = "Nimble Dragon",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "Agility +10% versus \nPhysical attacks.",
		power = 10,
		passive = PSV_DODGE,
	}

attackDefs["dextrous dragon"] = {
		name = "Dextrous Drg.",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "Agility +15% versus \nPhysical attacks.",
		power = 15,
		passive = PSV_DODGE,
	}

attackDefs["agile dragon"] = {
		name = "Agile Dragon",
		type = ATK_PASSIVE|ATK_STRIKE|ATK_PIERCE|ATK_SLASH,
		desc = "Agility +20% versus \nPhysical attacks.",
		power = 20,
		passive = PSV_DODGE,
	}

attackDefs["draconic boon"] = {
		name = "Draconic Boon",
		type = ATK_SUPPORT,
		costtype = CST_EP,
		cost = 2,
		desc = "Raise all of your team's stats \nby 1 stage.",
		target = TGT_ALLALLIES,
		superbuff = true,
		anim = function(mo, targets, hittargets, timer)
			for i = 1, #targets do
				local target = targets[i]

				local colors = {SKINCOLOR_ORANGE, SKINCOLOR_TEAL, SKINCOLOR_LAVENDER, SKINCOLOR_EMERALD}
	
				if timer == 20 + (i-1)*16
					playSound(mo.battlen, sfx_buff2)
					buffStat(target, "atk")
					buffStat(target, "mag")
					buffStat(target, "def")
					buffStat(target, "agi")
	
					BTL_logMessage(targets[1].battlen, "All stats increased!")
	
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_WHITE
						dust.scale = FRACUNIT*2
					end
	
				elseif timer > 20 + (i-1)*16 and timer <= 50 + (i-1)*16
	
					if leveltime%2 == 0
						for i = 1,16
	
							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.state = S_CDUST1
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_WHITE
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end
	
					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = colors[P_RandomRange(1, #colors)]
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 60 + (#targets-1)*16
					return true
				end
			end
		end,
	}
	
attackDefs["spyro_atk"] = {
		name = "Dragon Charge",
		type = ATK_STRIKE,
		power = 40,
		accuracy = 75,
		critical = 30,
		target = TGT_ENEMY,
		cost = CST_HP,
		cost = 0,
		desc = "A head-on charge at the enemy \nwith powerful dragon horns. \nHas low accuracy, but \nhigh critical hit chance.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if timer == 1
						ANIM_set(mo, mo.anim_special2, true)
						mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

						local cx = target.x + 168*cos(target.angle + ANG1*20)
						local cy = target.y + 168*sin(target.angle + ANG1*20)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
						S_StartSound(mo, sfx_charge)
					end

					local s = P_SpawnGhostMobj(mo)
					s.color = SKINCOLOR_DUSK
					P_InstaThrust(mo, mo.angle, FRACUNIT*60)

					if not mo.reachedtarget

						if mo.anim ~= mo.anim_special2
							ANIM_set(mo, mo.anim_special2, true)
						end

						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

						if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

							damageObject(atarget)
							playSound(mo.battlen, sfx_basha)
							playSound(mo.battlen, sfx_sbonk)
							mo.reachedtarget = timer

							for i=1,24
								local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
								b.momx = P_RandomRange(-32, 32)*FRACUNIT
								b.momy = P_RandomRange(-32, 32)*FRACUNIT
								b.momz = P_RandomRange(4, 16)*FRACUNIT
								b.state = S_AOADUST1
								b.frame = A|FF_FULLBRIGHT
								b.scale = FRACUNIT*3
								b.destscale = FRACUNIT/12
							end
							for i = 1, 4
								createSplat(mo)
							end
						end
					else

						if timer - mo.reachedtarget > 40
							return true
						end
					end
				end,
	}

//PvP ability changes
addHook("PostThinkFrame", do
	if not server return end

	if server.gamemode == GM_PVP
		attackDefs["draconic boon"].cost = 75
		attackDefs["draconic boon"].costtype = CST_SP
	else
		attackDefs["draconic boon"].cost = 2
		attackDefs["draconic boon"].costtype = CST_EP
	end
end)

//flammable SRB2P mobj
--table.insert(flammableEnemies, MT_SHEDEW)

//freeslot
VFX_freeslotC("spyro")

//and now for Persona-only movement code wheeheeheeeeihopethisactuallyfuckingworks
--worked around it by having charge be re-mapped to CUSTOM3 if srb2p is detected
DNG_Abilities["spyro"] = {

	jfunc = 	function(p)
					return true
				end,
	
	func =  	function(p)
					/*
					p.charflags = SF_NOJUMPSPIN 
					p.charflags = $ | SF_NOJUMPDAMAGE
					p.charflags = $ | SF_NOSKID
					p.charflags = $ | SF_HIRES 
					p.charflags = $ | SF_MULTIABILITY 
					p.charflags = $ | SF_SUPER
					
					p.normalspeed = 32*FRACUNIT
					p.runspeed = 20*FRACUNIT
					p.accelstart = 160
					p.acceleration = 30
					
					//jump factors
					if p.speed >= p.runspeed
						p.jumpfactor = (70*FRACUNIT)/100
					else
						p.jumpfactor = (11*FRACUNIT)/10
					end
					
					//dash mode sooner
					if p.dashmode < (TICRATE+(TICRATE/2))
						p.dashmode = (TICRATE+(TICRATE/2))
					end
					
					local mo = p.mo
					
					local flamed = false
					
					//so that PETEMAIN knows when to restrict Flaming
					if mo.state == S_PLAY_RUN
					or mo.state == S_PLAY_DASH
					or mo.state == S_PLAY_FALLCHARGE
						p.flamed = true
					end
					*/
					
					//STOP F***ING MOVING GODDAMNIT
					if p.mo.m_menu
						PLAY_nomove(p)
					end
					
					/*
					//no after-images unless fast enough; STOP RUNNING IN PLACE
					if p.speed >= p.runspeed
						p.charflags = $ | SF_DASHMODE
					elseif p.speed < p.runspeed
						if mo.state == S_PLAY_DASH
							mo.state = S_PLAY_WALK
						end
					end
					
					//glide speed cap
					if mo.state == (S_PLAY_GLIDE or S_PLAY_GLIDE_LOW or S_PLAY_FLY)
					and not P_IsObjectOnGround(mo)
						p.normalspeed = 20*FRACUNIT
					end
					
					//fallcharge anim
					if p.speed >= p.runspeed
						if not (mo.state == S_PLAY_FALLCHARGE)
							if (mo.state == ((S_PLAY_JUMP) or (S_PLAY_FALL)))
							and not P_IsObjectOnGround(mo)
								mo.state = S_PLAY_FALLCHARGE
							end
						end
					end 
					*/
					/*
					//skamper sound
					if mo.state == S_PLAY_RUN
					and P_IsObjectOnGround(mo)
					and not S_SoundPlaying(mo, sfx_charge)
						S_StartSound(mo, sfx_charge)
					elseif (mo.state ~= S_PLAY_RUN)
					or not P_IsObjectOnGround(mo)
					and S_SoundPlaying(mo, sfx_charge)
						S_StopSoundByID(mo, sfx_charge)
					end
						
					//super skamper sound
					if p.dashmode >= 3*TICRATE
					and P_IsObjectOnGround(mo)
					and not S_SoundPlaying(mo, sfx_scharg)
						S_StartSound(mo, sfx_scharg)
					elseif p.dashmode < 3*TICRATE
					or not P_IsObjectOnGround(mo)
					and S_SoundPlaying(mo, sfx_scharg)
						S_StopSoundByID(mo, sfx_scharg)
					end
					*/
				end
}

--prethink handling
/*
addHook("PreThinkFrame", function()
	if not srb2p then return end
	
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
			--nothin' here
		end
	end
end)
*/

--prethink stuff
addHook("PreThinkFrame", function()
	if not srb2p then return end
	
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
			--don't move in menus
			if p.mo.m_menu
				PLAY_nomove(p)
				p.mo.momx = 0
				p.mo.momy = 0
			end
		end
	end
end)

--post think handling
addHook("PostThinkFrame", function()
	if not srb2p then return end
	
	for p in players.iterate
		if p.mo and p.mo.skin == "spyro"
			--auto close menu if spyro is in the air
			if not P_IsObjectOnGround(p.mo)
			and p.mo.menu
				M_closeMenu(p.mo)
			end
			
			--start noptic if starting battle
			if p.mo.evt_startbattle
			or p.mo.readybattle
				p.charging = false
				p.aircharging = false
				p.noptic = 5
				PLAY_nomove(p)
			end
			
			--force charging off if in battle
			if server.P_BattleStatus[p.P_party] and server.P_BattleStatus[p.P_party].running
			and (p.charging or p.aircharging)
				p.charging = false
				p.aircharging = false
				p.noptic = 5
			end
			
			/*
			--force dashmode if charging
			if p.charging or p.aircharging
				p.charflags = $ | SF_DASHMODE
				if p.dashmode < 2*TICRATE
					p.dashmode = 2*TICRATE
				end
			else
				p.charflags = $ & ~SF_DASHMODE
			end
			*/
		end
	end
end)

addHook("MobjMoveCollide", function(mo, enemy)
	if not srb2p then return end
	
	--don't proc if we vertically miss
	if(enemy.z > mo.z+mo.height) or (mo.z > enemy.z+enemy.height+(2*FRACUNIT))
		return nil
	end
	
	if mo.player and mo.player.valid
		local p = mo.player
		
		--give spyro dashmode when touching ANYTHING while charging
		--that and reset player input with noptic
		if p.mo.skin == "spyro"
			if p.charging or p.aircharging
				p.charflags = $ | SF_DASHMODE
				p.dashmode = 4*TICRATE
				
				p.noptic = 5
			end
		end
	end
end, MT_PLAYER)