if not srb2p return end

-- Spyro game element definitions, by Tatsuru

rawset(_G, "spyro", {})


//
// Various assets
//

freeslot("MT_SPYRO_NUM", 
	"S_SPYRO_DUMMY", 
	"SPR_BSKT", "SPR_SGTW", "SPR_SBAL")

mobjinfo[MT_SPYRO_NUM] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	speed = 8*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY
}

states[S_SPYRO_DUMMY] = {
	sprite = SPR_NULL,
	tics = -1,
	nextstate = S_SPYRO_DUMMY
}


//
// Sparx
//

freeslot("MT_SPARX", "MT_SPARX_WINGS", "MT_SPARX_HOME", "MT_SPARX_PARTICLE", "SPR_SPRX", "SPR_SPXW", "SPR_SPRT")

mobjinfo[MT_SPARX] = {
	doomednum = -1,
	spawnstate = S_SPYRO_DUMMY,
	spawnhealth = 3,
	speed = 8*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SHOOTABLE|MF_NOCLIPHEIGHT|MF_SLIDEME
}

mobjinfo[MT_SPARX_WINGS] = {
	doomednum = -1,
	spawnstate = S_SPYRO_DUMMY,
	speed = 8*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SPARX_HOME] = {
	doomednum = -1,
	spawnstate = S_SPYRO_DUMMY,
	speed = 8*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOSECTOR|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_SPARX_PARTICLE] = {
	doomednum = -1,
	spawnstate = S_SPYRO_DUMMY,
	speed = FRACUNIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

//
// Utility functions
//


rawset(_G, "HeightCheck", function(abottom, atop, bbottom, btop)
	if abottom > btop return false end
	if bbottom > atop return false end
	
	return true
end)

rawset(_G, "HomingChase", function(mo, target, speed, xoffs, yoffs, zoffs, thrust)
	xoffs = $ or 0
	yoffs = $ or 0
	zoffs = $ or 0
	
	local xthrust = thrust and xoffs or 0
	local ythrust = thrust and yoffs or 0
	local zthrust = thrust and zoffs or 0
	
	local newx = target.x + xoffs
	local newy = target.y + yoffs
	local newz = target.z + zoffs
	local dist = R_PointToDist2(0, 0, R_PointToDist2(mo.x, mo.y, newx, newy), newz - mo.z)
	
	if speed < dist
		mo.momx = FixedMul(FixedDiv(newx - mo.x, dist), speed) + xthrust
		mo.momy = FixedMul(FixedDiv(newy - mo.y, dist), speed) + ythrust
		mo.momz = FixedMul(FixedDiv(newz - mo.z, dist), speed) + zthrust
	elseif speed > dist
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		P_TeleportMove(mo, newx, newy, newz)
		return true
	end
end)